 #ifndef OPERATEURSSPECIAUX_H
 #define OPERATEURSSPECIAUX_H 
 #include "ReelInfini.h" 
 #include "EntierInfini.h" 
 #include "Error.h" 


/*	liste des erreurs : 
		501 : Racine d'un nombre ngatif impossible
		502 : Logarithme d'un nombre ngatif ou nul
		503 : Mauvaise base du logarithme
*/



 ReelInfini obtenirPuissance(ReelInfini,EntierInfini); 

// retourne -1 si le nombre donn est un nombre ngatif (erreur 501)
 ReelInfini obtenirRacine(ReelInfini); 

// retourne -1 si le nombre donn est ngatif ou nul (erreur 502)
// retourne -1 si la base donne n'est pas valide (erreur 503)
 ReelInfini obtenirLogarithme(ReelInfini,ReelInfini); 

 ReelInfini obtenirExponentielle(ReelInfini); 

// les constantes : 

 ReelInfini obtenirPi(); 
 ReelInfini obtenirE(); 
 ReelInfini obtenirNombreDor(); 
 ReelInfini obtenirEulerMascheroni();  

 #endif
