#include "max.h"

void libererStruct(typeRetourneParDollar notreStructure)
{printf("max.c : Liberation de variable\n");
 if(notreStructure.aDetruire==0)
	{
		switch (notreStructure.type)
                        {
                        case 0 : libererEntierInfini(notreStructure.notreEntier);
                                 break;
	
                        case 1 :libererReelInfini(notreStructure.notreReel);
                                printf("max.c : On revient dans libererStruct\n");
                                break;

			case 2 ://detruireUneMatrice(notreStructure.notreMatrice);
			         break;

                        default: printf("max.c : Erreur de type a la destruction\n\tArret du programme\n");
			         exit(0);
                        }
                printf("max.c : On sort de libererStruct\n");
	}
}


void afficher(typeRetourneParDollar dollar)
{
char* affichage;
//Affichage du resultat avec les fonctions de conversion entier vers chaine propose par les autres groupes
 printf("max.c : On rentre dans la fonction d'affichage\n");
 if(dollar.type==0){
	affichage=afficherUnEntierInfiniAPartirDe(dollar.notreEntier);
	printf("Resultat = %s\n",affichage);
	free(affichage);
	libererStruct(dollar);
	}
 if(dollar.type==1){
        printf("max.c : On va afficher 2 ReelInfinis\n");
	affichage=afficherUnReelInfiniAPartirDe(dollar.notreReel);
	printf("Resultat : %s\n",affichage);
        free(affichage);
	libererStruct(dollar);
	}
 /*if(dollar.type==2){
        afficherMatrice(dollar.notreMatrice);
	libererStruct(dollar);
	free(affichage);
	}*/
}
/*
void afficherMatrice(Matrice matriceAAfficher)
{
int hauteur,longueur,i,j;
char* affichage;
hauteur=obtenirLaHauteur(matriceAAfficher);
if(verifierErreur()==603){
	printf("%s",expliquerErreur(603));
	free(matriceAAfficher);}
longueur=obtenirLaLongueur(matriceAAfficher);
if(verifierErreur()==603){
	printf("%s",expliquerErreur(603));
	free(matriceAAfficher);}
for(i=1;i<=hauteur;i++)
	{
	printf("\t");
	for(j=1;j<=longueur;j++)
		{
		affichage=afficherUnReelInfiniAPartirDe(obtenirLaValeurDUnElement(matriceAAfficher,i,j));
		if(verifierErreur()==603){
			printf("%s",expliquerErreur(603));
			free(matriceAAfficher);
			free(affichage);}
		if(verifierErreur()==605){
			printf("%s",expliquerErreur(605));
			free(matriceAAfficher);
			free(affichage);}
		printf(" %s",affichage);
		}
	printf("\n");
	}
	free(matriceAAfficher);
	free(affichage);
}


typeRetourneParDollar affecter(typeRetourneParDollar dollar1,typeRetourneParDollar dollar3)
{
typeRetourneParDollar resultat;
Memoire maMemoire=memoire();
if(verifierErreur()==244){
	printf("%s",expliquerErreur(244));
	libererStruct(dollar3);
	exit(0);}
creerVariable(maMemoire,dollar1.notreVariable);
if(verifierErreur()==244){
	printf("%s",expliquerErreur(244));
	libererStruct(dollar3);
	exit(0);}
if(dollar3.type==0){
        fixerValeurEntier(maMemoire,dollar1.notreVariable,dollar3.notreEntier);
        if(verifierErreur()==244){
	        printf("%s",expliquerErreur(244));
	        libererStruct(dollar3);
	        exit(0);}
        if(verifierErreur()==222){
	        printf("%s",expliquerErreur(222));
	        libererStruct(dollar3);
	        exit(0);}
        resultat.type=0;
        resultat.notreEntier=dollar3.notreEntier;
        resultat.aDetruire=1;
        libererStruct(dollar3);
        return resultat;}
if(dollar3.type==1){
	fixerValeurReel(maMemoire,dollar1.notreVariable,dollar3.notreReel);
	if(verifierErreur()==244){
		printf("%s",expliquerErreur(244));
		libererStruct(dollar3);
		exit(0);}
	if(verifierErreur()==222){
	        printf("%s",expliquerErreur(222));
		libererStruct(dollar3);
		exit(0);}
	resultat.type=1;
	resultat.notreReel=dollar3.notreReel;
	resultat.aDetruire=1;
	libererStruct(dollar3);
	return resultat;}
if(dollar3.type==2){
	fixerValeurMatrice(maMemoire,dollar1.notreVariable,dollar3.notreMatrice);
	if(verifierErreur()==244){
		printf("%s",expliquerErreur(244));
		libererStruct(dollar3);
		exit(0);}
	if(verifierErreur()==222){
		printf("%s",expliquerErreur(222));
		libererStruct(dollar3);
		exit(0);}
	resultat.type=2;
	resultat.notreMatrice=dollar3.notreMatrice;
	resultat.aDetruire=1;
	libererStruct(dollar3);
	return resultat;}
}
*/
typeRetourneParDollar calculDeLaFactorielle(typeRetourneParDollar dollar1)
{typeRetourneParDollar resultat;
resultat.notreEntier=calculerFactorielleDe(dollar1.notreEntier);
if(verifierErreur()==302){
	printf("%s",expliquerErreur(302));
	libererStruct(dollar1);
	libererStruct(resultat);
	exit(0);}
resultat.type=0;
resultat.aDetruire=0;
return resultat;
libererStruct(dollar1);
}


typeRetourneParDollar calculDeLArrangement(typeRetourneParDollar dollar1,typeRetourneParDollar dollar3)
{typeRetourneParDollar resultat;
 resultat.notreEntier=calculerArrangementDe(dollar1.notreEntier,dollar3.notreEntier);
 if(verifierErreur()==303){
        printf("%s",expliquerErreur(303));
        libererStruct(dollar1);
        libererStruct(dollar3);
        libererStruct(resultat);
        exit(0);}
 if(verifierErreur()==304){
        printf("%s",expliquerErreur(304));
        libererStruct(dollar1);
        libererStruct(dollar3);
        libererStruct(resultat);
        exit(0);}
 resultat.type=0;
 resultat.aDetruire=0;
 return resultat;
 libererStruct(dollar1);
 libererStruct(dollar3);
}

typeRetourneParDollar calculDeLaCombinaison(typeRetourneParDollar dollar1,typeRetourneParDollar dollar3)
{typeRetourneParDollar resultat;
 resultat.notreEntier=calculerCombinaisonDe(dollar1.notreEntier,dollar3.notreEntier);
 if(verifierErreur()==305){
	printf("%s",expliquerErreur(305));
	libererStruct(dollar1);
        libererStruct(dollar3);
	libererStruct(resultat);
	exit(0);}
 if(verifierErreur()==306){
	printf("%s",expliquerErreur(306));
	libererStruct(dollar1);
        libererStruct(dollar3);
	libererStruct(resultat);
	exit(0);}
 resultat.type=0;
 resultat.aDetruire=0;
 return resultat;
 libererStruct(dollar1);
 libererStruct(dollar3);
}


