#include "sam.h"

typeRetourneParDollar multiplication(typeRetourneParDollar terme1,typeRetourneParDollar terme2)
	{
	if(terme1.type==0 && terme2.type==0)	// Multiplication Entier par Entier 
		{
		typeRetourneParDollar resultat;
		resultat.type=0;
		resultat.notreEntier=multiplierDeuxEntiersInfinis(terme1.notreEntier,terme2.notreEntier);
		resultat.aDetruire=0;
		return resultat;
		}
	/*if(terme1.type==1&&terme2.type==1)	// Multiplication Reel par Reel 
		{
		typeRetourneParDollar resultat;
		resultat.type=1;
		resultat.notreReel=multiplierDeuxReelsInfinis(terme1.notreReel,terme2.notreReel);
		resultat.aDetruire=0;
		return resultat;
		}
	if(terme1.type==2&&terme2.type==2)	// Multiplication Matrice par Matrice 
		{
		typeRetourneParDollar resultat;
		resultat.type=2;
		resultat.notreMatrice=multiplierDeuxMatrices(terme1.notreMatrice,terme2.notreMatrice);
		resultat.aDetruire=0;
		if (verifierErreur()==603)
			{
			printf("Erreur : %s\n",expliquerErreur(603));
			libererStruct(resultat);
			exit(1);
			}
		if (verifierErreur()==604)
			{
			printf("Erreur : %s\n",expliquerErreur(604));
			libererStruct(resultat);
			exit(1);
			}
		return resultat;
		}
	if(terme1.type==2&&terme2.type==1)	// Multiplication Matrice par Reel
		{
		typeRetourneParDollar resultat;
		resultat.type=2;
		resultat.notreMatrice=multiplierUneMatriceParUnScalaire(terme1.notreMatrice,terme2.notreReel);
		resultat.aDetruire=0;
		if (verifierErreur()==603)
			{
			printf("Erreur : %s\n",expliquerErreur(603));
			libererStruct(resultat);
			exit(1);
			}
		return resultat;
		}
	if(terme1.type==1&&terme2.type==2)	// Multiplication Reel par Matrice 
		{
		typeRetourneParDollar resultat;
		resultat.type=2;
		resultat.notreMatrice=multiplierUneMatriceParUnScalaire(terme2.notreMatrice,terme1.notreReel);
		resultat.aDetruire=0;
		if (verifierErreur()==603)
			{
			printf("Erreur : %s\n",expliquerErreur(603));
			libererStruct(resultat);
			exit(1);
			}
		return resultat;
		}
	if(terme1.type==2&&terme2.type==0)	// Multiplication Matrice par Entier
		{
		typeRetourneParDollar resultat;
		resultat.type=2;
		resultat.notreMatrice=multiplierUneMatriceParUnScalaire(terme1.notreMatrice,convertirUnEntierInfiniVersUnReelInfini(terme2.notreEntier));
		resultat.aDetruire=0;
		if (verifierErreur()==603)
			{
			printf("Erreur : %s\n",expliquerErreur(603));
			libererStruct(resultat);
			exit(1);
			}
		return resultat;
		}
	if(terme1.type==0&&terme2.type==2)	// Multiplication Entier par Matrice 
		{
		typeRetourneParDollar resultat;
		resultat.type=2;
		resultat.notreMatrice=multiplierUneMatriceParUnScalaire(terme2.notreMatrice,convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier));
		resultat.aDetruire=0;
		if (verifierErreur()==603)
			{
			printf("Erreur : %s\n",expliquerErreur(603));
			libererStruct(resultat);
			exit(1);
			}
		return resultat;
		}*/
	libererStruct(terme1);
	libererStruct(terme2);			
}

typeRetourneParDollar division(typeRetourneParDollar terme1,typeRetourneParDollar terme2)
	{
	if(terme1.type==0&&terme2.type==0)	// Division de Entier par Entier 
		{
		typeRetourneParDollar resultat;
		resultat.type=0;
		resultat.notreEntier=diviserDeuxEntiersInfinis(terme1.notreEntier,terme2.notreEntier);
		resultat.aDetruire=0;
		if(verifierErreur()==300)
			{
			printf("Erreur : %s\n",expliquerErreur(300));
			libererStruct(resultat);
			exit(1);
			}  
		return resultat;
		}
	/*if(terme1.type==1&&terme2.type==1)	// Divison Reel par Reel 
		{
		typeRetourneParDollar resultat;
		resultat.type=1;
		resultat.notreReel=diviserDeuxReelsInfinis(terme1.notreReel,terme2.notreReel);
		resultat.aDetruire=0;
		if(verifierErreur()==310)
			{
			printf("Erreur : %s\n",expliquerErreur(310));
			libererStruct(resultat);
			exit(1);
			}  
		return resultat;
		}
	if(terme1.type==0&&terme2.type==1)	// Divison Entier par Reel 
		{
		typeRetourneParDollar resultat;
		resultat.type=1;
		resultat.notreReel=diviserDeuxReelsInfinis(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier),terme2.notreReel);
		resultat.aDetruire=0;
		if(verifierErreur()==310)
			{
			printf("Erreur : %s\n",expliquerErreur(310));
			libererStruct(resultat);
			exit(1);
			}  
		return resultat;
		}
        if(terme1.type==1&&terme2.type==0)	// Divison Reel par Entier 
		{
		typeRetourneParDollar resultat;
		resultat.type=1;
		resultat.notreReel=diviserDeuxReelsInfinis(terme1.notreReel,convertirUnEntierInfiniVersUnReelInfini(terme2.notreEntier));
		resultat.aDetruire=0;
		if(verifierErreur()==310)
			{
			printf("Erreur : %s\n",expliquerErreur(310));
			libererStruct(resultat);
			exit(1);
			}  
		return resultat;
		}*/
	libererStruct(terme1);
	libererStruct(terme2);
	}
/*
typeRetourneParDollar exposant(typeRetourneParDollar terme1,typeRetourneParDollar terme2)
	{
	if(terme1.type==0&&terme2.type==0)	// Un Entier exposant un Entier 
		{
		typeRetourneParDollar resultat;
		resultat.type=1;
		resultat.notreEntier=convertirUnReelInfiniVersUnEntierInfini(obtenirPuissance(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier),terme2.notreEntier));
		resultat.aDetruire=0;
		if (verifierErreur()==501)
			{
			printf("Erreur : %s\n",expliquerErreur(501));
			libererStruct(resultat);
			exit(1);
			}
		return resultat;
		}
	if(terme1.type==1&&terme2.type==0)	// Un Reel exposant un Entier 
		{
		typeRetourneParDollar resultat;
		resultat.type=1;
		resultat.notreReel=obtenirPuissance(terme1.notreReel,terme2.notreEntier);
		resultat.aDetruire=0;
		if (verifierErreur()==501)
			{
			printf("Erreur : %s\n",expliquerErreur(501));
			libererStruct(resultat);
			exit(1);
			}
		return resultat;
		}
	libererStruct(terme1);
	libererStruct(terme2);
	}

typeRetourneParDollar multiplicationPoint(typeRetourneParDollar terme1,typeRetourneParDollar terme2)
	{
	if(terme1.type==2&&terme2.type==2)	// Multiplication terme a terme de deux matrices 
		{
		typeRetourneParDollar resultat;
		resultat.type=2;
		resultat.notreMatrice=multiplierTermeATermeDeuxMatrices(terme1.notreMatrice,terme2.notreMatrice);
		resultat.aDetruire=0;
		if (verifierErreur()==603)
			{
			printf("Erreur : %s\n",expliquerErreur(603));
			libererStruct(resultat);
			exit(1);
			}
		if (verifierErreur()==604)
			{
			printf("Erreur : %s\n",expliquerErreur(604));
			libererStruct(resultat);
			exit(1);
			}
		return resultat;
		}
	libererStruct(terme1);
	libererStruct(terme2);
	}

*/
