%{				/* Librairies a inclure ici si necessaire */
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "Error.h"
#include "EntierInfini.h"
#include "ReelInfini.h"
#include "zabou.h"
#include "virgule.tab.h"

int  possedeUneVirgule(char* );
YYSTYPE yylval;

%}

chiffre 	[0-9]
Decimal         \,{chiffre}+
Nombre          {chiffre}+{Decimal}?|{chiffre}+
Caractere       [A|C]

%%



{Nombre}                  {char* partieEntiere;
                           char* partieReelle;
                           int i,indiceVirgule,precision;
                           if ( possedeUneVirgule (yytext) == 0 ) { // On a trouve un entier
			        printf("virgule.lex : On reconnait un entier\n");
                                yylval.entier = creerUnEntierInfiniAPartirDe (yytext,'+');
                                return NbeEntier;
			   }
                           else {                                  //On a trouve un reel
                                 i=0;
                                 partieEntiere=(char*) calloc(strlen(yytext),sizeof(char));
                                 do { 
				       partieEntiere[i] = yytext[i];
                                       i=i+1;
				       } 
			         while ( yytext[i] != ',');
				 indiceVirgule=i;
                                 precision=obtenirPrecision();
				 partieReelle=(char*) calloc(strlen(yytext),sizeof(char));
				 for(i=0;i<=precision-1;i++){
				       partieReelle[i] = yytext[indiceVirgule+1+i];
				       }	
                                 yylval.reel = creerUnReelInfiniAPartirDe ( partieEntiere, partieReelle, '+');
                                 return NbeReel;}
                             }





{Caractere}               {return yytext[0];}

[\+\-\*\/\^.!;\,()[]|\=]    {return yytext[0];}


[ \t]                     {yyerror("Lex : Caractere inconnu\n");}

%%



int possedeUneVirgule ( char* tab ) {
     int i,reponse=0;
     for ( i=0; i< strlen(tab) ; i++ ) {
       if ( tab[i] == ',') {
	 reponse = reponse + 1;
       }
     }
     if ( reponse >= 2 ) {
       printf (" Lex : 2 virgules dans un meme nombre\n");
       exit(0);
     }
     return reponse;
}



                           
