
//////////////////////////////////////////////////////////////////
/*                                                              */
/*                      Variable.h                              */
/*                                                              */
//////////////////////////////////////////////////////////////////

#ifndef VARIABLE_H
#define VARIABLE_H
#define Chaine char* 

#include "Booleen.h"
#include "EntierInfini.h"
#include "ReelInfini.h"
#include "Matrice.h"

//typedef enum {Faux=0, Vrai=1} Booleen;

typedef struct Variable * Variable;



//constructeur
Variable nouvelleVariable (Chaine);

//Fonctionnalits

Chaine obtenirNom(Variable);
 
void fixerVariableEntier(Variable, EntierInfini);
void fixerVariableReel(Variable,ReelInfini);
void fixerVariableMatrice(Variable,Matrice);

Booleen estUneVariableEntier(Variable);
Booleen estUneVariableReel(Variable);
Booleen estUneVariableMatrice(Variable);

EntierInfini obtenirVariableEntier(Variable);
ReelInfini obtenirVariableReel(Variable);
Matrice obtenirVariableMatrice(Variable);

void libererLaVariable(Variable*);
void detruireValeur(Variable);

#endif 





